@echo off
pushd "%~dp0"
setlocal



:: Usage check:
if "%~1" equ "" echo Usage: "%~0" python.exe_to_use path_to_squish_for_qt_installation
if "%~1" equ "" exit /b

if "%~2" equ "" echo Usage: "%~0" python.exe_to_use path_to_squish_for_qt_installation
if "%~2" equ "" exit /b



:: Path to Squish package; its python2/python3 folder MUST
:: be a Python with same major, minor version and
:: architecture as the Python used for execution below:
set SQUISH_PREFIX=%~2



:: To find the "squishtest" module and shared libraries
:: it depends on:
set PYTHONPATH=%SQUISH_PREFIX%\bin;%PYTHONPATH%



:: To find these Squish modules:
::  objectmaphelper (possibly used in names.py)
::  remotesystem
::  screen
::  toplevelwindow
set PYTHONPATH=%SQUISH_PREFIX%\lib\python;%PYTHONPATH%



:: Create results folders (ignore errors):
mkdir results >nul 2>&1
set RESULTS_DIR=%CD%/results



:: Stop squishserver (if still running):
"%SQUISH_PREFIX%\bin\squishserver" --stop >nul 2>&1



:: Launch squishserver in background:
start "" /min cmd /c ""%SQUISH_PREFIX%\bin\squishserver" --verbose >"%RESULTS_DIR%/squishserver_log.txt" 2>&1"



:: Test if squishserver available:
"%SQUISH_PREFIX%\bin\squishrunner" --info all >nul 2>&1
if %errorlevel% equ 0 goto after_squishserver_check
echo Accessing squishserver failed, retrying...
ping -n 2 localhost >nul

"%SQUISH_PREFIX%\bin\squishrunner" --info all >nul 2>&1
if %errorlevel% equ 0 goto after_squishserver_check
echo Accessing squishserver failed, retrying...
ping -n 2 localhost >nul

"%SQUISH_PREFIX%\bin\squishrunner" --info all >nul 2>&1
if %errorlevel% equ 0 goto after_squishserver_check
echo Accessing squishserver failed, aborting.
"%SQUISH_PREFIX%\bin\squishserver" --stop >nul
exit /b



:after_squishserver_check



:: Add "lib" folder in same directory as this .bat file to
:: PYTHONPATH, so that the Robot Framework can find it
:: (required for the module "names" (names.py) too!):
set PYTHONPATH=%~dp0\lib;%PYTHONPATH%

set AUT=%SQUISH_PREFIX%/examples/qt/addressbook/addressbook
set AUT_WRAPPER=Qt



:: Execute Python script that uses squishtest:
"%~1" -m robot -d "%RESULTS_DIR%" addressbook_tests



:: Stop squishserver:
"%SQUISH_PREFIX%\bin\squishserver" --stop >nul



endlocal
popd
